<script lang="ts" setup>
import type { Booking, Promo, Room } from '@/entities';
import { usePromoStore } from '@/stores/promo';
import { useRoomStore } from '@/stores/room';
import { storeToRefs } from 'pinia';
import { ref, toRef } from 'vue';
import CalendarComponentByRoom from './CalendarComponentByRoom.vue';
import CalendarComponentByPromo from './CalendarComponentByPromo.vue';
import type { Dayjs } from 'dayjs';
import { computed } from '@vue/reactivity';
import dayjs from 'dayjs';


const props = defineProps<{
  bookings: Booking[],
  day: Dayjs
}>();

const day = toRef(props, 'day');
const bookings = toRef(props, 'bookings');

const storeRoom = useRoomStore();
const { rooms } = storeToRefs(storeRoom);

const storePromo = usePromoStore();
const { promos } = storeToRefs(storePromo);

const emitMonth = defineEmits({
  changeMonth(day: number) { return true },
  getToday() { return true },
  dateSelect(booking: Booking) { return true }
});

const calByPromo = ref(false);

const roomDisplay = ref<Room>(rooms.value[0]);

const promoDisplay = ref<Promo>(promos.value[0]);

const componentKey = ref(0);

const calendar = ref()

const selectDate = (val: string) => {
  calendar.value.selectDate(val)

  switch (val) {
    case 'prev-month':
      emitMonth('changeMonth', -30);
      break;
    case 'next-month':
      emitMonth('changeMonth', 30);
      break;
    case 'today':
      emitMonth('getToday');
  }

}

const bookingsByDay = computed(() => {
  const bookingMap = new Map<string, { am: Booking | undefined, pm: Booking | undefined }>();
  for (let i = -5; i <= day.value.daysInMonth() + 5; i++) {
    const today = day.value.date(i);
    if (calByPromo.value) {

      bookingMap.set(today.format('DD/MM'), {
        am: bookings.value.find(item => promoDisplay.value.id == item.promo?.id && today.hour(12).isAfter(item.startDate) && today.hour(12).isBefore(item.endDate)),
        pm: bookings.value.find(item => promoDisplay.value.id == item.promo?.id && today.hour(14).isAfter(item.startDate) && today.hour(14).isBefore(item.endDate)),
      })
    } else {
      bookingMap.set(today.format('DD/MM'), {
        am: bookings.value.find(item => roomDisplay.value.id == item.room?.id && today.hour(12).isAfter(item.startDate) && today.hour(12).isBefore(item.endDate)),
        pm: bookings.value.find(item => roomDisplay.value.id == item.room?.id && today.hour(14).isAfter(item.startDate) && today.hour(14).isBefore(item.endDate)),
      })

    }
  }
  return bookingMap;
});

function changeRoom(index: any) {
  roomDisplay.value = rooms.value[index];
  componentKey.value += 1; // reload component
}

function changePromo(index: any) {
  promoDisplay.value = promos.value[index];
  componentKey.value += 1; // reload component
}


const dateSelect = (date: Date) => {
  console.log(date);
  
  if (!calByPromo.value) {
    let booking: Booking = { startDate: date, endDate: date, room: roomDisplay.value };
    const found = bookings.value.find(item => item.room?.id == roomDisplay.value.id && dayjs(date).hour(12).isBefore(item.endDate) && dayjs(date).hour(12).isAfter(item.startDate));
    if (found) {
      booking = found;
    }
    emitMonth('dateSelect', booking);
  }
}

</script>


<template >
  <main>
    <el-row>
      <el-col :span="6">
        <aside>
          <el-switch v-model="calByPromo" class="mb-2" active-text="affichage par Promo"
            inactive-text="affichage par salles" v-on:change="changeRoom(0); changePromo(0);" />
          <el-carousel v-if="!calByPromo" :autoplay="false" trigger="click" type="card" height="100px"
            v-on:change="changeRoom">
            <el-carousel-item v-for="room in rooms" :key="room.id">
              <h3 text="2xl" justify="center">{{ room.name }}</h3>
            </el-carousel-item>
          </el-carousel>
          <el-carousel v-if="calByPromo" :autoplay="false" trigger="click" type="card" height="100px"
            v-on:change="changePromo">
            <el-carousel-item v-for="promo in promos" :key="promo.id">
              <h3 text="2xl" justify="center">{{ promo.name }}</h3>
            </el-carousel-item>
          </el-carousel>

        </aside>
      </el-col>
      <el-col :span="18">
        <article>

          <el-calendar ref="calendar" class="rooms">
            <template #header="{ date }">
              <span>{{ date }}</span>
              <el-button-group>

                <el-button size="small" @click="selectDate('prev-month')">
                  Previous Month
                </el-button>
                <el-button size="small" @click="selectDate('today')">Today</el-button>
                <el-button size="small" @click="selectDate('next-month')">
                  Next Month
                </el-button>
              </el-button-group>
            </template>
            <template #date-cell="{ data }" v-if="!calByPromo">
              <div @click="dateSelect(data.date)" class="select-cell">
                <calendar-component-by-room :key="componentKey" :data="data"
                  v-if="bookingsByDay.has(dayjs(data.date).format('DD/MM'))"
                  :bookings="bookingsByDay.get(dayjs(data.date).format('DD/MM'))!" />
              </div>
            </template>
            <template #date-cell="{ data }" v-if="calByPromo">
              <div @click="dateSelect(data.date)" class="select-cell">
                <calendar-component-by-promo :key="componentKey" :data="data"
                  v-if="bookingsByDay.has(dayjs(data.date).format('DD/MM'))"
                  :bookings="bookingsByDay.get(dayjs(data.date).format('DD/MM'))!" />
              </div>
            </template>
          </el-calendar>


        </article>
      </el-col>

    </el-row>




  </main>
</template>

<style scoped>
.rooms {
  font-size: xx-small;
}

.is-selected {
  color: #1989fa;
}

.el-carousel__item h3 {
  color: #475669;
  opacity: 0.75;
  line-height: 100px;
  margin: 0;
  text-align: center;
}

.el-carousel__item:nth-child(2n) {
  background-color: #f8dce3;
}

.el-carousel__item:nth-child(2n + 1) {
  background-color: #fae6eb;
}

.select-cell {
  height: 100%;
}
</style>